//Ant.cpp - implementation of Ant class

#include "Lion.h"
#include "Ant.h"
using namespace std;

//default constructor (just for type-testing)
Ant::Ant(){}

//"practical" constructor used for ants we want to use
//takes in a pointer to the world and the width and height of the world
Ant::Ant( World *worldIn, int widthIn, int heightIn ){
	world = worldIn;
	width = widthIn;
	height = heightIn;
	livedfor = 0;//life begins now!
}

//virtual destructor
Ant::~Ant(){}

//try to move to a side-facing adjacent space
void Ant::move(){

	//a nonce Organism to plunk down behind itself if it moves
	Organism *spaceFiller;

    //only move once per iteration
	if (this->isTurn()) return;
	//increment lived for
	livedfor++;
	this->endTurn(); //don't move again after this

	                //pick a dir
					int randomdir = this->world->genrand(4);
					//try to move in that dir
					switch (randomdir) {
					  case 0://N
						//can we move north?
						  	if (x>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y));//N
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x-1,y));
								if ((long)pLion == 0 && (long)pAnt == 0) //it's free; I can move
								{
									this->setPosition(x-1,y);//change my coordinates
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);//place myself
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x+1,y);//place the nonce
								}
							}
						break;
					  case 1://E
							if (y<width-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y+1));//E
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y+1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									this->setPosition(x,y+1);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x,y-1);
								}
							}
						break;
					  case 2://S
							if (x<height-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y));//S
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x+1,y));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									this->setPosition(x+1,y);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x-1,y);
								}
							}
						break;
					  case 3://W
							if (y>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y-1));//W
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y-1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									this->setPosition(x,y-1);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x,y+1);
								}
							}
						break;
					  default://WUT
						cout << "SQEEEE! I don't know which way to move!";
					  }
}

//every third turn, try to breed to a side-facing adjacent space
//if no space available, too bad
void Ant::breed(){

	bool alreadyBred = false;
	if (livedfor >= 3)//though we reset it anyway
	{
		//any room to breed?
		vector<int> canBreed;//places I can breed to
	    canBreed.clear();
	
		    //can we breed north?
	                        if (x>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y));//N
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x-1,y));
								if ((long)pLion == 0 && (long)pAnt == 0) //it's free; I can breed there
								{
									canBreed.push_back(N);
								}
							}
			
			//can we breed east?
							if (y<width-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y+1));//E
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y+1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(E);
								}
							}
			//can we breed south?
							if (x<height-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y));//S
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x+1,y));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(S);
								}
							}
		   // can we breed west?
							if (y>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y-1));//W
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y-1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(W);
								}
							}

						    //if we found an place to birth to, pick one to birth to at random
							if (canBreed.size() > 0)
							{
								birth(canBreed.at(this->world->genrand(canBreed.size())));
								alreadyBred = true;
							}

							//if (alreadyBred)
								livedfor = 0;//bred or not!
	}

}

//create new ant one space away in given direction
void Ant::birth(int dirIn){

	        if (dirIn==N)//create new ant one space north
			{
					Ant *pNewAnt = new Ant(this->world, width, height);//make a new ant
					pNewAnt->setPosition(x-1,y);//tell it where it is
					this->world->setOrganism(pNewAnt,x-1,y);//plunk it on the grid
			}
			else if (dirIn==E)
			{
					Ant *pNewAnt = new Ant(this->world, width, height);
					pNewAnt->setPosition(x,y+1);
					this->world->setOrganism(pNewAnt,x,y+1);
			}
			else if (dirIn==S)
			{
					Ant *pNewAnt = new Ant(this->world, width, height);
					pNewAnt->setPosition(x+1,y);
					this->world->setOrganism(pNewAnt,x+1,y);
			}
			else //(dirIn==W)
			{
                    Ant *pNewAnt = new Ant(this->world, width, height);
					pNewAnt->setPosition(x,y-1);
					this->world->setOrganism(pNewAnt,x,y-1);
			}
}