//Organism.cpp - implementation for Organism class

#include "Organism.h"
#include "Ant.h"//just for sake of the output operator
#include "Lion.h"//ditto
using namespace std;

//default constructor (used for space-filling and type-matching)
Organism::Organism(){}

//virtual destructor
Organism::~Organism(){}

//these functions are only implemented by lions and ants
void Organism::move(){}
void Organism::breed(){}
void Organism::birth(int dirIn){}

//set the organism's awareness of its position
void Organism::setPosition(int xin, int yin){
	x = xin;
	y = yin;
}

//set eligibilty to move
void Organism::startTurn(){
	this->moved = false;
}

//withdraw eligibility to move
void Organism::endTurn(){
	this->moved = true;
}

//can I still move?
bool Organism::isTurn(){
	return this->moved;
}

//output operator (out of class)
//outputs a character representing the organism
//called by the output operator for the World
ostream& operator<<( ostream &output, Organism *organism )
{
	//dynamic casts to see what kind of organism it is
	Lion *pLion = dynamic_cast<Lion*>(organism);
	Ant *pAnt = dynamic_cast<Ant*>(organism);
			if ((long)pLion != 0)//it's a lion
			{
				//red
				SetConsoleTextAttribute(GetStdHandle( STD_OUTPUT_HANDLE ), FOREGROUND_RED | FOREGROUND_INTENSITY);
				output << "X";
				//reset to gray
	            SetConsoleTextAttribute(GetStdHandle( STD_OUTPUT_HANDLE ), FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
			}
			else if ((long)pAnt != 0)//it's an ant
			{
				//green
				SetConsoleTextAttribute(GetStdHandle( STD_OUTPUT_HANDLE ), FOREGROUND_GREEN | FOREGROUND_INTENSITY);
				output << "O";
				//reset to gray
	            SetConsoleTextAttribute(GetStdHandle( STD_OUTPUT_HANDLE ), FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
			}
			else //it's a nonce (empty)
				output << " ";
		
	return output;
}//end friend<<