//World.h - header for World class

#pragma once
#ifndef _WORLD_H
#define _WORLD_H

#include <iostream>
#include <cstdlib> 
#include <ctime>
#include <Windows.h>

using namespace std;

class Organism;

//set height and width of world here:
const int GRID_WIDTH = 20;
const int GRID_HEIGHT = 20;

class World
{
protected:

	//array of Organisms (shared throughout with pointers)
	Organism *grid[GRID_HEIGHT][GRID_WIDTH];

public:
	World();//fired once by the driver
	virtual ~World();//virtual destructor

	Organism *getOrganism( int x, int y );//returns Organism given coordinates
	void setOrganism( Organism *organism, int x, int y );//sets supplied Organism at supplied coordinates

	void run();//runs a time step (called by the driver)
	int genrand(int range);//returns a random number given a starting point and range

	friend ostream& operator<<( ostream &output, World &world );//outputs the state of the world (called by the driver)

};

#endif
